# HW2DReaderCommon

## Types

| `CoordinateMode`

## Fields

| `logical_coords`
| `application_coords`
| `recentered_coords`
std::map< int, H_FORMAT_TEXT > | `lay_num_map`
H_FORMAT_TEXT | `m_layerName`
bool | `m_layer_visibility`
double | `m_z_plane`
double | `m_z_separation`
double | `m_use_depth_range`
double | `m_depth_range`
CoordinateMode | `m_CoordMode`
WT_Units * | `m_pWhipUnits`
double | `m_x_extents`
double | `m_y_extents`
int | `m_layer_stack`
bool | `m_unmark_detector`
H_UTF8 | `m_current_url`
HColor | `m_Color`
HPoint | `m_text_path`
char | `m_font`
char | `m_fontName`
char | `m_backupFont`
char | `m_fontStyle`
char | `m_fontHeight`
char | `m_fontScale`
char | `m_fontOblique`
double | `m_line_edge_weight`
bool | `m_visible`
char | `m_hAlignment`
bool | `m_resort`
char | `m_object_id`
bool | `m_bDisableDWFDrawOrder`
double | `m_priority`
bool | `m_bImportThumbnail`
HColor | `m_backgroundColor`
HPoint | `m_plotInfoMin`
HPoint | `m_plotInfoMax`
int | `m_plotInfoUnits`
int | `m_pageWidth`
int | `m_pageHeight`

## Functions

| `HW2DReaderCommon`
| `HW2DReaderCommon`
| `HW2DReaderCommon`
| `~HW2DReaderCommon`
void | `init`
bool | `compute_extents`
WT_Result | `read`
int | `incrementImageCount`
void | `setFillMode`
bool | `fillMode`
WT_Result | `process_stream_close`
WT_Result | `process_stream_end_seek`
WT_Result | `process_stream_open`
WT_Result | `process_stream_read`
WT_Result | `process_stream_seek`
WT_Result | `process_stream_tell`
WT_Result | `process_stream_write`
WT_Result | `_importPolytriangle`
WT_Result | `_importText`
bool | `is_this_face_really_a_hole`
WT_Result | `_importContourNode`
WT_Result | `_importEllipse`
WT_Result | `_importPolyline`
WT_Result | `_importPolygon`
WT_Result | `_importImage`
WT_Result | `_importPNG_Group4_Image`
WT_Result | `import_line_weight`
WT_Result | `_importLineWeight`
WT_Result | `_importFill`
void | `apply_object_attrs`
WT_Result | `_importColor`
WT_Result | `_importViewport`
WT_Result | `_importLayer`
WT_Result | `_importColorMap`
WT_Result | `_importObjectNode`
WT_Result | `_importPlotInfo`
WT_Result | `_importInkedArea`
WT_Result | `_importNamedView`
WT_Result | `_importFont`
WT_Result | `_importVisibility`
WT_Result | `_importHAlignment`
WT_Result | `_importUnits`
WT_Result | `_importURL`
WT_Result | `_importView`
WT_Result | `_importBackground`
void | `resort_start`
void | `resort_finish`
void | `resort_close`
void | `resort_open`
void | `resort_segment`
WT_Result | `_processPolyMarker`
WT_Result | `_processPolytriangle`
WT_Result | `_processText`
WT_Result | `_processContourNode`
WT_Result | `_processEllipse`
WT_Result | `_processPolyline`
WT_Result | `_processPolygon`
WT_Result | `_processImage`
WT_Result | `_processPNG_Group4_Image`
WT_Result | `_processColorMap`
WT_Result | `_processURL`
WT_Result | `_processLineWeight`
WT_Result | `_processFill`
WT_Result | `_processColor`
WT_Result | `_processViewport`
WT_Result | `_processView`
WT_Result | `_processFont`
WT_Result | `_processVisibility`
WT_Result | `_processBackground`
WT_Result | `_processHAlignment`
WT_Result | `_processObjectNode`
WT_Result | `_processPlotInfo`
WT_Result | `_processInkedArea`
WT_Result | `_processNamedView`
WT_Result | `_processLayer`
WT_Result | `_processUnits`

## Detailed Description

class HW2DReaderCommon

  Public Types

  enum CoordinateMode

    Values:

    enumerator logical_coords
    enumerator application_coords
    enumerator recentered_coords

  Public Functions

  HW2DReaderCommon(WT_File *whip_file, DWFInputStream *rW2DStream, HInputHandlerOptions *pInputHandlerOptions, HC_KEY model_key, bool rebaseModel, HInputHandler *m, CoordinateMode coord_mode = recentered_coords)
  HW2DReaderCommon(WT_File *whip_file, DWFToolkit::DWFResource *pResource, HInputHandlerOptions *pInputHandlerOptions, HC_KEY model_key, bool rebaseModel, HInputHandler *m, CoordinateMode coord_mode = recentered_coords)
  HW2DReaderCommon(WT_File *whip_file, DWFToolkit::DWFResource *pResource, DWFToolkit::DWFSection *pSection, HInputHandlerOptions *pInputHandlerOptions, HC_KEY model_key, bool rebaseModel, bool is_dwfx, HInputHandler *m, CoordinateMode coord_mode = recentered_coords)
  ~HW2DReaderCommon()
  void init()
  bool compute_extents(DWFInputStream &input_stream)
  WT_Result read(double z_separation, double depth_range_separation)
  int incrementImageCount()
  void setFillMode(bool val)
  inline bool fillMode()
  inline WT_Result process_stream_close()
  inline WT_Result process_stream_end_seek()
  WT_Result process_stream_open()
  WT_Result process_stream_read(int desired_bytes, int &bytes_read, void *buffer)
  WT_Result process_stream_seek(int distance, int &amount_seeked)
  WT_Result process_stream_tell(unsigned long *current_file_pointer_position)
  inline WT_Result process_stream_write(int size, void const *buffer)
  WT_Result _importPolytriangle(WT_Polytriangle &polytriangle)
  WT_Result _importText(WT_Text &text)
  bool is_this_face_really_a_hole(int point_count, HPoint const *points)
  WT_Result _importContourNode(WT_Contour_Set &contour_set)
  WT_Result _importEllipse(WT_Outline_Ellipse &e)
  WT_Result _importPolyline(WT_Polyline &polyline)
  WT_Result _importPolygon(WT_Polygon &polygon)
  WT_Result _importImage(WT_Image &image)
  WT_Result _importPNG_Group4_Image(WT_PNG_Group4_Image &image)
  WT_Result import_line_weight(WT_Line_Weight &lw)
  inline WT_Result _importLineWeight(WT_Line_Weight &lw)
  WT_Result _importFill(WT_Fill &rFill)
  void apply_object_attrs(HC_KEY key)
  WT_Result _importColor(WT_Color &rColor)
  WT_Result _importViewport(WT_Viewport &viewport)
  WT_Result _importLayer(WT_Layer &layer)
  WT_Result _importColorMap(WT_Color_Map &color_map)
  WT_Result _importObjectNode(WT_Object_Node &object_node)
  WT_Result _importPlotInfo(WT_Plot_Info &plot_info, WT_File &file)
  inline WT_Result _importInkedArea(WT_Inked_Area &inked_area, WT_File &file)
  WT_Result _importNamedView(WT_Named_View &named_view)
  WT_Result _importFont(WT_Font &font)
  WT_Result _importVisibility(WT_Visibility &visibility)
  WT_Result _importHAlignment(WT_Text_HAlign &hAln)
  WT_Result _importUnits(WT_Units &units)
  WT_Result _importURL(WT_URL &named_url)
  WT_Result _importView(WT_View &view)
  WT_Result _importBackground(WT_Background &background)
  void resort_start()
  void resort_finish()
  void resort_close()
  void resort_open()
  void resort_segment()

  Public Members

  std::map<int, H_FORMAT_TEXT> lay_num_map
  H_FORMAT_TEXT m_layerName
  bool m_layer_visibility
  double m_z_plane
  double m_z_separation
  double m_use_depth_range
  double m_depth_range
  CoordinateMode m_CoordMode
  WT_Units *m_pWhipUnits
  double m_x_extents
  double m_y_extents
  int m_layer_stack
  bool m_unmark_detector
  H_UTF8 m_current_url
  HColor m_Color
  HPoint m_text_path
  char m_font[MVO_BUFFER_SIZE]
  char m_fontName[100]
  char m_backupFont[100]
  char m_fontStyle[100]
  char m_fontHeight[100]
  char m_fontScale[100]
  char m_fontOblique[100]
  double m_line_edge_weight
  bool m_visible
  char m_hAlignment[4]
  bool m_resort
  char m_object_id[MVO_BUFFER_SIZE]
  bool m_bDisableDWFDrawOrder
  double m_priority
  bool m_bImportThumbnail
  HColor m_backgroundColor
  HPoint m_plotInfoMin
  HPoint m_plotInfoMax
  int m_plotInfoUnits
  int m_pageWidth
  int m_pageHeight

  Public Static Functions

  static WT_Result _processPolyMarker(WT_Polymarker &polymarker, WT_File &file)
  static WT_Result _processPolytriangle(WT_Polytriangle &polytriangle, WT_File &file)
  static WT_Result _processText(WT_Text &text, WT_File &file)
  static WT_Result _processContourNode(WT_Contour_Set &contour_set, WT_File &file)
  static WT_Result _processEllipse(WT_Outline_Ellipse &e, WT_File &file)
  static WT_Result _processPolyline(WT_Polyline &polyline, WT_File &file)
  static WT_Result _processPolygon(WT_Polygon &polygon, WT_File &file)
  static WT_Result _processImage(WT_Image &image, WT_File &file)
  static WT_Result _processPNG_Group4_Image(WT_PNG_Group4_Image &image, WT_File &file)
  static WT_Result _processColorMap(WT_Color_Map &color_map, WT_File &file)
  static WT_Result _processURL(WT_URL &named_url, WT_File &file)
  static WT_Result _processLineWeight(WT_Line_Weight &lw, WT_File &file)
  static WT_Result _processFill(WT_Fill &rFill, WT_File &file)
  static WT_Result _processColor(WT_Color &rColor, WT_File &file)
  static WT_Result _processViewport(WT_Viewport &viewport, WT_File &file)
  static WT_Result _processView(WT_View &view, WT_File &file)
  static WT_Result _processFont(WT_Font &font, WT_File &file)
  static WT_Result _processVisibility(WT_Visibility &visibility, WT_File &file)
  static WT_Result _processBackground(WT_Background &background, WT_File &file)
  static WT_Result _processHAlignment(WT_Text_HAlign &hAln, WT_File &file)
  static WT_Result _processObjectNode(WT_Object_Node &object_node, WT_File &file)
  static WT_Result _processPlotInfo(WT_Plot_Info &plot_info, WT_File &file)
  static WT_Result _processInkedArea(WT_Inked_Area &inked_area, WT_File &file)
  static WT_Result _processNamedView(WT_Named_View &named_view, WT_File &file)
  static WT_Result _processLayer(WT_Layer &layer, WT_File &file)
  static WT_Result _processUnits(WT_Units &units, WT_File &file)